// src/backend/default_resource_policy_manager.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA


#include "resource_policy_lifo.hh"
#include "default_resource_policy_manager.hh"
#include "resource_policies_gatekeeper.hh"

using namespace sgpem;

// instantiate a default instance of this class.
DefaultResourcePolicyManager DefaultResourcePolicyManager::_default_instance;


DefaultResourcePolicyManager::DefaultResourcePolicyManager()
{
	ResourcePolicy * lifo = new ResourcePolicyLiFo();
	_policies.push_back(lifo);
  ResourcePoliciesGatekeeper::get_instance().register_manager(this);
  // Includes default policies.
  _policies.push_back(new ResourcePolicyLiFo());
}


DefaultResourcePolicyManager::~DefaultResourcePolicyManager()
{
  ResourcePoliciesGatekeeper::get_instance().unregister_manager(this);
}

const std::vector<ResourcePolicy*>&
DefaultResourcePolicyManager::get_avail_policies() const
{
  return _policies;
}
